/*
* Copyright (c) 2019-2025 Allwinner Technology Co., Ltd. ALL rights reserved.
*
* Allwinner is a trademark of Allwinner Technology Co.,Ltd., registered in
* the the People's Republic of China and other countries.
* All Allwinner Technology Co.,Ltd. trademarks are used with permission.
*
* DISCLAIMER
* THIRD PARTY LICENCES MAY BE REQUIRED TO IMPLEMENT THE SOLUTION/PRODUCT.
* IF YOU NEED TO INTEGRATE THIRD PARTY¡¯S TECHNOLOGY (SONY, DTS, DOLBY, AVS OR MPEGLA, ETC.)
* IN ALLWINNERS¡¯SDK OR PRODUCTS, YOU SHALL BE SOLELY RESPONSIBLE TO OBTAIN
* ALL APPROPRIATELY REQUIRED THIRD PARTY LICENCES.
* ALLWINNER SHALL HAVE NO WARRANTY, INDEMNITY OR OTHER OBLIGATIONS WITH RESPECT TO MATTERS
* COVERED UNDER ANY REQUIRED THIRD PARTY LICENSE.
* YOU ARE SOLELY RESPONSIBLE FOR YOUR USAGE OF THIRD PARTY¡¯S TECHNOLOGY.
*
*
* THIS SOFTWARE IS PROVIDED BY ALLWINNER"AS IS" AND TO THE MAXIMUM EXTENT
* PERMITTED BY LAW, ALLWINNER EXPRESSLY DISCLAIMS ALL WARRANTIES OF ANY KIND,
* WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING WITHOUT LIMITATION REGARDING
* THE TITLE, NON-INFRINGEMENT, ACCURACY, CONDITION, COMPLETENESS, PERFORMANCE
* OR MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
* IN NO EVENT SHALL ALLWINNER BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS, OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __MBUS_SUN20IW1_H__
#define __MBUS_SUN20IW1_H__

typedef struct {
    uint32_t MC_MCGCR;
    uint32_t MC_CPU_BWCR;
    uint32_t MC_RV_SYS_BWCR;
    uint32_t MC_MAHB_BWCR;
    uint32_t MC_DMA_BWCR;
    uint32_t MC_VE_BWCR;
    uint32_t MC_CE_BWCR;
    uint32_t MC_TVD_BWCR;
    uint32_t MC_CSI_BWCR;
    uint32_t MC_DSP_SYS_BWCR;
    uint32_t MC_G2D_BWCR;
    uint32_t MC_DI_BWCR;
    uint32_t MC_DE_BWCR;
    uint32_t MC_IOMMU_BWCR;
    uint32_t MC_XXX_BWCR;
    uint32_t MC_OTHER_BWCR;
    uint32_t MC_TOTAL_BWCR;
}MBUS_PMU_REGISTER_T;


#define MBUS_CTRL_BASE  0x03102000
#define MBUS_PMU_BASE   (MBUS_CTRL_BASE + 0x009c)

#define MBUS_PMU        ((MBUS_PMU_REGISTER_T *)(MBUS_PMU_BASE))

#endif
