/*
* Copyright (c) 2019-2025 Allwinner Technology Co., Ltd. ALL rights reserved.
*
* Allwinner is a trademark of Allwinner Technology Co.,Ltd., registered in
* the the People's Republic of China and other countries.
* All Allwinner Technology Co.,Ltd. trademarks are used with permission.
*
* DISCLAIMER
* THIRD PARTY LICENCES MAY BE REQUIRED TO IMPLEMENT THE SOLUTION/PRODUCT.
* IF YOU NEED TO INTEGRATE THIRD PARTY’S TECHNOLOGY (SONY, DTS, DOLBY, AVS OR MPEGLA, ETC.)
* IN ALLWINNERS’SDK OR PRODUCTS, YOU SHALL BE SOLELY RESPONSIBLE TO OBTAIN
* ALL APPROPRIATELY REQUIRED THIRD PARTY LICENCES.
* ALLWINNER SHALL HAVE NO WARRANTY, INDEMNITY OR OTHER OBLIGATIONS WITH RESPECT TO MATTERS
* COVERED UNDER ANY REQUIRED THIRD PARTY LICENSE.
* YOU ARE SOLELY RESPONSIBLE FOR YOUR USAGE OF THIRD PARTY’S TECHNOLOGY.
*
*
* THIS SOFTWARE IS PROVIDED BY ALLWINNER"AS IS" AND TO THE MAXIMUM EXTENT
* PERMITTED BY LAW, ALLWINNER EXPRESSLY DISCLAIMS ALL WARRANTIES OF ANY KIND,
* WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING WITHOUT LIMITATION REGARDING
* THE TITLE, NON-INFRINGEMENT, ACCURACY, CONDITION, COMPLETENESS, PERFORMANCE
* OR MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
* IN NO EVENT SHALL ALLWINNER BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS, OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __PLATFORM_WDT_H__
#define __PLATFORM_WDT_H__

#include "sunxi_hal_watchdog.h"

/* Base Address */
#if defined(CONFIG_ARCH_SUN8IW18P1)
#define WDT_BASE        0x030090a0  /* @TODO */
#elif defined(CONFIG_ARCH_SUN8IW19)
#define WDT_BASE        0x030090a0  /* @TODO */
#elif defined(CONFIG_SOC_SUN20IW1) /* RISC-V */
#define WDT_BASE                0x020500A0
#endif

/* watchdog register offset */
#define WDT_IRQ_EN              (WDT_BASE + 0x00)
#define WDT_STA                 (WDT_BASE + 0x04)
#define WDT_CTL                 (WDT_BASE + 0x10)
#define WDT_CFG                 (WDT_BASE + 0x14)
#define WDT_MODE                (WDT_BASE + 0x18)
//#define WDT_OUT_CFG             (WDT_BASE + 0x1C)

//#define WDT_TIMEOUT             16

#define WDT_CTRL_RESTART        (0x1 << 0)
#define WDT_CTRL_KEY            (0x0a57 << 1)

#define WDT_CFG_RESET           (0x1)
#define WDT_MODE_EN             (0x1)
#define KEY_FIELD_MAGIC         (0x16AA0000)

struct hal_sunxi_wdt {
        volatile u32 irq_en;    //0x00
        volatile u32 sta;       //0x04
        volatile u32 rsl[2];
        volatile u32 ctl;       //0x10
        volatile u32 cfg;       //0x14
        volatile u32 mode;      //0x18
};

#endif /* __PLATFORM_WDT_H__ */
